#!/bin/sh
##-----------------------------------------------------------------------------
## opt/files/usr/local/bin/faxsend.sh                             3.0.1
##
##        P L E A S E   R E A D   T H E   D O C U M E N T A T I O N ,
##
##        B I T T E  U N B E D I N G T   D I E   D O K U M E N T A T I O N
##
## Creation:     	Christian Raatz 0.1.1 fli4l@schinkensaft.de
## Last Update:	31.01.2006  jens kluge <jk@web.de>
## Support: 	Christian Schuermann, Joan Wolter, Felix Eckhofer (Many thanks!!!)
## Thx to:   	Thomas Unger, Thomas Klingler, Peter Schiefer, Manfred Schliesing
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##-----------------------------------------------------------------------------

initialize()
{
# read configuration
. /var/run/faxsend.conf
imond_port=`cat /var/run/imond.port`
CR=`echo -e '\r'`
idx=""
idxparameters=""

    REDATE=
    case $customredate in
	yes) REDATE=`date` ;;
    esac

req_sff="no"
req_gjpeg="no"
req_jpeg="no"
req_gpdf="no"
req_pdf="no"
req_ps="no"
req_pbm="no"
req_gpbm="no"

DATE=`date`
TIME=`date +%y%m%d%H%M`
onlinecheck=$FAXSEND_ONLINECHECK
}

### Update Variables to current idx
varupdate()
{
	eval from='$FAXSEND_'$idx'_FROM'
	eval to='$FAXSEND_'$idx'_TO'
	#eval popcheck='$FAXSEND_'$idx'_POPCHECK'
	eval gzip='$FAXSEND_'$idx'_GZIP'

	#eval mailuser='$FAXSEND_'$idx'_MAILUSER'
	eval mailuser='$FAXSEND_MAILUSER'

	#eval mailpwd='$FAXSEND_'$idx'_MAILPWD'
	eval mailpwd='$FAXSEND_MAILPWD'

	#eval popsvr='$FAXSEND_'$idx'_POPSVR'
	eval popsvr='$FAXSEND_POPSVR'

	#eval popport='$FAXSEND_'$idx'_POPPORT'
	eval popport='$FAXSEND_POPPORT'

	#eval smtpsvr='$FAXSEND_'$idx'_SMTPSVR'
	eval smtpsvr='$FAXSEND_SMTPSVR'

	#eval smtpport='$FAXSEND_'$idx'_SMTPPORT'
	eval smtpport='$FAXSEND_SMTPPORT'

	#eval waitsvr='$FAXSEND_'$idx'_WAITSVR'
	eval waitsvr='$FAXSEND_WAITSVR'
	eval notifyonly='$FAXSEND_'$idx'_NOTIFYONLY'
	eval notifyaddr='$FAXSEND_'$idx'_NOTIFYADDR'
	eval customre='$FAXSEND_'$idx'_CUSTOMRE'
	eval customredate='$FAXSEND_'$idx'_CUSTOMREDATE'
	eval delfax='$FAXSEND_'$idx'_DELFAX'
	eval format='$FAXSEND_'$idx'_FORMAT'
	eval encode='$FAXSEND_'$idx'_ENCODE'
}

### Delete temp-files
cleanup()
{
colecho "OPT_FAXSEND Temporaere Dateien loeschen ....." cy
rm -f $TIME*
#rm -f smtp$TIME.cmd
#rm -f /tmp/smtp$TIME.cmd  /tmp/faxtmp.sff
rm -f plainstring authstring auth smtpcmd
colecho "OPT_FAXSEND Temporaere Dateien geloescht !" gn
}



### Delete original Fax-Msg on Router and Update mfax.log
del_fax ()
{
colecho "OPT_FAXSEND Remove Fax: $fax" gn
if [ -w $fax ]
then
	rm -f $fax
	if [ -e $fax ]
	then
		colecho "OPT_FAXSEND Remove Fax fehlgeschlagen!: $fax" rd
	else
		colecho "OPT_FAXSEND Fax removed ..." gn
		# ------------- begin mfax.log update
		sed -e "/$filename/d" $mfax > /tmp/mfax_tmp.log && mv /tmp/mfax_tmp.log $mfax
		# ------------- endof mfax.log update
	fi
else
	colecho "OPT_FAXSEND Remove Fax nicht moeglich fuer: $fax" rd
fi
}



### generate smtp.cmd-file
generate_smtp_cmd()
{
    REDATE=
    case $customredate in
	yes) REDATE=`date` ;;
    esac

    # Manfred Schliesing 07/2005: RFC Conform Mailaddress
    # ----->  <$from> <$to> <$notifyaddr> 
    case $notifyonly in
	no) nach="$to" ;;
	*)  nach="$notifyaddr" ;;
    esac

    {
	cat <<EOF
HELO $smtpsvr$CR
mail from: <$from>$CR
rcpt to: <$to>$CR
data$CR
Date: $DATE$CR
From: <$from>$CR
Reply-To: <$nach>$CR
To: <$nach>$CR
Content-type: multipart/mixed; boundary="frontier---faxsend---frontier"$CR
MIME-version: 1.0$CR
Subject: $customre $REDATE$CR
$CR

--frontier---faxsend---frontier$CR
Content-type: text/plain$CR

Fax wurde empfangen fuer $csid.$CR

EOF


# Fax versandfertig machen
		case ${notifyonly}${gzip}${format} in
		    noyessff)	echo "$CR--frontier---faxsend---frontier$CR"
				echo "Content-type: application/x-zip; name=$filename$CR"
				if [ $encode = "base64" ]
				  then
				     echo "Content-transfer-encoding: base64$CR$CR"
				     echo "$CR"
				     uuencode -m $fax $fax | sed -e '1d' -e '$d'
				     #base64 -e $fax
				  else
				     echo "Content-transfer-encoding: x-uuencode$CR"
				     echo "Content-Disposition: attachment; filename=$filename$CR$CR"
				     echo "$CR"
				     uuencode $fax $TIME.sff.gz
				fi ;;

		    nonosff)	echo "$CR--frontier---faxsend---frontier$CR"
				echo "Content-type: image/g3fax; name=$TIME.sff$CR"
				if [ $encode = "base64" ]
				  then
				     echo "Content-transfer-encoding: base64$CR$CR"
				     echo "$CR"
				     uuencode -m $TIME.sff $TIMS.sff | sed -e '1d' -e '$d'
				     #base64 -e $TIME.sff
				  else
				     echo "Content-transfer-encoding: x-uuencode$CR"
				     echo "Content-Disposition: attachment; filename=$TIME.sff$CR$CR"
				     echo "$CR"
				     uuencode $TIME.sff $TIME.sff
				fi ;;

		    noyesjpeg)	for i in *.jpg.gz
				do
				echo "$CR--frontier---faxsend---frontier$CR"
				echo "Content-type: application/x-zip; name=$i$CR"

				if [ $encode = "base64" ]
				  then
				     echo "Content-transfer-encoding: base64$CR$CR"
				     echo "$CR"
				     uuencode -m $i $i | sed -e '1d' -e '$d'
				     #base64 -e $i
				  else
				     echo "Content-transfer-encoding: x-uuencode$CR"
				     echo "Content-Disposition: attachment; filename=$i$CR$CR"
				     echo "$CR"
				     uuencode $i $i
				fi
				done ;;

		    nonojpeg)	for i in *.jpg
				do
				echo "$CR--frontier---faxsend---frontier$CR"
				echo "Content-type: image/jpeg; name=$i$CR"

				if [ $encode = "base64" ]
				  then
				     echo "Content-transfer-encoding: base64$CR$CR"
				     echo "$CR"
				     uuencode -m $i $i | sed -e '1d' -e '$d'
				     #base64 -e $i
				  else
				     echo "Content-transfer-encoding: x-uuencode$CR"
				     echo "Content-Disposition: attachment; filename=$i$CR$CR"
				     echo "$CR"
				     uuencode $i $i
				fi
				done ;;

		    noyespbm)	for i in *.pbm.gz
				do
				echo "$CR--frontier---faxsend---frontier$CR"
				echo "Content-type: image/x-portable-bitmap; name=$i$CR"

				if [ $encode = "base64" ]
				  then
				     echo "Content-transfer-encoding: base64$CR$CR"
				     echo "$CR"
				     uuencode -m $i $i | sed -e '1d' -e '$d'
				     #base64 -e $i
				  else
				     echo "Content-transfer-encoding: x-uuencode$CR"
				     echo "Content-Disposition: attachment; filename=$i$CR$CR"
				     echo "$CR"
				     uuencode $i $i
				fi
				done ;;

		    nonopbm)	for i in *.pbm
				do
				echo "$CR--frontier---faxsend---frontier$CR"
				echo "Content-type: image/x-portable-bitmap; name=$i$CR"

				if [ $encode = "base64" ]
				  then
				     echo "Content-transfer-encoding: base64$CR$CR"
				     echo "$CR"
				     uuencode -m $i $i | sed -e '1d' -e '$d'
				     #base64 -e $i
				  else
				     echo "Content-transfer-encoding: x-uuencode$CR"
				     echo "Content-Disposition: attachment; filename=$i$CR$CR"
				     echo "$CR"
				     uuencode $i $i
				fi
				done ;;

		    noyespdf)	echo "$CR--frontier---faxsend---frontier$CR"
				echo "Content-type: application/x-zip; name=$TIME.pdf.gz$CR"
				if [ $encode = "base64" ]
				  then
				     echo "Content-transfer-encoding: base64$CR$CR"
				     echo "$CR"
				     uuencode -m $TIME.pdf.gz $TIME.pdf.gz | sed -e '1d' -e '$d'
				     #base64 -e $TIME.pdf.gz
				  else
				     echo "Content-transfer-encoding: x-uuencode$CR"
				     echo "Content-Disposition: attachment; filename=$TIME.pdf.gz$CR$CR"
				     echo "$CR"
				     uuencode $TIME.pdf.gz $TIME.pdf.gz
				fi ;;

		    nonopdf)	echo "$CR--frontier---faxsend---frontier$CR"
				echo "Content-type: application/pdf; name=$TIME.pdf$CR"
				if [ $encode = "base64" ]
				  then
				     echo "Content-transfer-encoding: base64$CR$CR"
				     echo "$CR"
				     uuencode -m $TIME.pdf $TIME.pdf | sed -e '1d' -e '$d'
				     #base64 -e $TIME.pdf
				  else
				     echo "Content-transfer-encoding: x-uuencode$CR"
				     echo "Content-Disposition: attachment; filename=$TIME.pdf$CR$CR"
				     echo "$CR"
				     uuencode $TIME.pdf $TIME.pdf
				fi ;;	
		esac

	cat <<EOF
$CR
--frontier---faxsend---frontier--$CR

$CR
.$CR
quit$CR
quit$CR
quit$CR
EOF
    }  > /tmp/smtp$TIME.cmd
}



### Pump the smtp.cmd to smtp-server...
send_fax()
{
    colecho "OPT_FAXSEND $smtpsvr:$smtpport SEND $fax" cy
    colecho "OPT_FAXSEND from <$from> to <$nach>" cy

if [ "$OPT_FAXSEND_USE_EXT_SMTP" = "no" ]
    then
     ## use netcat to pump smtp.cmd to server
     netcat -w $waitsvr $smtpsvr $smtpport < /tmp/smtp$TIME.cmd

    else

     ## fix smtp.cmd for proper use with msmtp/ssmtp, i.e. remove all lines till real data appears
     sed '1,4d' /tmp/smtp$TIME.cmd > /tmp/smtp$TIME.cmd.tmp && mv /tmp/smtp$TIME.cmd.tmp /tmp/smtp$TIME.cmd

     ## let the smtp-client do the rest...
     if [ "$OPT_FAXSEND_SMTP_CLIENT" = "msmtp" ] 
	then
	msmtp.sh -m /tmp/smtp$TIME.cmd
	else
	ssmtp.sh -m /tmp/smtp$TIME.cmd
     fi

fi
    colecho "OPT_FAXSEND Fax gesendet !" gn
}

### Just a quick login at smtp-server
pop_login()
{
### If we do pop-before-smtp...
    colecho "OPT_FAXSEND $popsvr:$popport <$mailuser> (POPCHECK)" cy
    echo -e "user $mailuser\npass $mailpwd\r\nquit" | netcat -i $waitsvr $popsvr $popport
    colecho "OPT_FAXSEND popcheck fertig" gn
}


### Generate the AUTH-PLAIN-string and put it on top of smtp.cmd
smtp_auth()
{
## Generate AUTH-PLAIN-string and write it to 'plainstring'
echo -e "\000${mailuser}\000${mailpwd}" > plainstring
## Remove all LineFeeds in 'plainstring' and write result to 'authstring'
tr -d '\012' < plainstring >>authstring
## Put the SMTP-Auth-Type (AUTH PLAIN) on top of file 'auth'
echo -e "AUTH PLAIN" > auth

## Encode 'authstring' and write it to file 'auth'
#base64 -e authstring >> auth
uuencode -m authstring authstring | sed -e '1d' -e '3d' >> auth

## Make copy of smtp.cmd and paste content of file 'auth' on top
cp /tmp/smtp$TIME.cmd smtpcmd
sed '$r smtpcmd' auth > /tmp/smtp$TIME.cmd
}

make_files()
{
### Check, which files are required, 
### solve dependecies to make sure, that files are not generated twice
### and finally generate files from fax


## Check, which files are required
for idx in $idxparameters
do
    varupdate
    case ${notifyonly}${gzip}${format} in
	noyessff)  ;;

	nonosff)	if [ "$req_sff"   != "yes" ] 
				then req_sff="yes" 
			fi ;;

	noyesjpeg) 	if [ "$req_gjpeg" != "yes" ]
				then req_gjpeg="yes" 
			fi ;;

	nonojpeg)  	if [ "$req_jpeg"  != "yes" ] 
				then req_jpeg="yes"
			fi ;;

	noyespdf)	if [ "$req_gpdf"  != "yes" ] 
				then req_gpdf="yes"
			fi ;;

	nonopdf)	if [ "$req_pdf"   != "yes" ]
				then req_pdf="yes"
			fi ;;

	noyespbm) 	if [ "$req_gpbm" != "yes" ]
				then req_gpbm="yes" 
			fi ;;

	nonopbm)  	if [ "$req_pbm"  != "yes" ] 
				then req_pbm="yes"
			fi ;;
    esac
done

##Add here check if prn for faxprint is needed...


   
### solve dependencies between created files
if [ "$req_jpeg" = "yes" ] 
then 
     if [ "$req_sff" != "yes" ] 
	then req_sff=yes
     fi
fi

if [ "$req_gjpeg" = "yes" ] 
then 
     if [ "$req_sff"  != "yes" ]
	then req_sff=yes
     fi
     if [ "$req_jpeg" != "yes" ]
	then req_jpeg=yes
     fi
fi

if [ "$req_pdf" = "yes" ] 
then 
     if [ "$req_sff" != "yes" ]
	then req_sff=yes
     fi
     if [ "$req_ps"  != "yes" ]
	then req_ps=yes
     fi
fi

if [ "$req_gpdf" = "yes" ] 
then 
     if [ "$req_sff" != "yes" ]
	then req_sff=yes
     fi
     if [ "$req_ps"  != "yes" ]
	then req_ps=yes
     fi
     if [ "$req_pdf" != "yes" ]
	then req_pdf=yes
     fi
fi

if [ "$req_pbm" = "yes" ] 
then 
     if [ "$req_sff" != "yes" ] 
	then req_sff=yes
     fi
fi

if [ "$req_gpbm" = "yes" ] 
then 
     if [ "$req_sff"  != "yes" ]
	then req_sff=yes
     fi
     if [ "$req_pbm" != "yes" ]
	then req_pbm=yes
     fi
fi

###Finally, generate files
if [ "$req_sff" = "yes" ]
then
     gzip -dcf $fax > $TIME.sff
fi

if [ "$req_jpeg" = "yes" ]
then
     case "`echo $filename | cut -b1-2`" in
     	fn) conv_option="-d" ;;
	*)  conv_option="-j" ;;
     esac

     sff2misc $conv_option $TIME.sff $TIME
fi

if [ "$req_gjpeg" = "yes" ]
then

     for i in *.jpg
     do
        gzip $i
        gzip -dcf $i.gz > $i
     done
fi

if [ "$req_pbm" = "yes" ]
then
     sff2misc -m $TIME.sff $TIME
fi

if [ "$req_gpbm" = "yes" ]
then

     for i in *.pbm
     do
        gzip $i
        gzip -dcf $i.gz > $i
     done
fi

if [ "$req_ps" = "yes" ]
then
     sff2misc -p $TIME.sff $TIME
fi

if [ "$req_pdf" = "yes" ]
then
     /usr/local/bin/gs -q -dBATCH -dNOPAUSE -sDEVICE=pdfwrite -sOutputFile=$TIME.pdf /opt/files/usr/local/bin/margins.ps $TIME.ps
fi

if [ "$req_gpdf" = "yes" ]
then
     gzip $TIME.pdf
     gzip -dcf $TIME.pdf.gz > $TIME.pdf
fi
###End of make files
}


#-------------------------------------------------------------------------
# connect to wan if offline and save in status_wan_old
#-------------------------------------------------------------------------
wan_connect ()
{
    # check whether router offline and save in status_wan_old
    status_dsl=`fli4lctrl status pppoe`
    status_isdn="offline"
    if ( `isdnctrl status all | grep to >/dev/null` )
    then
	status_isdn="online"
    fi

    status_wan_old="offline"
    echo 

    case $status_dsl in
	online)
	    # DSL Online?
	    status_wan_old="online"
	    colecho "OPT_FAXSEND (Router war online (DSL)...." rd 0 br
	;;
    esac

    case $status_isdn in
	online)
	    # ISDN Online ?
	    status_wan_old="online"
	    colecho "OPT_FAXSEND (Router war online (ISDN)..." rd 0 br
	;;
    esac

    # connect if offline and test loop to be sure that it works
    # >>> bei faxprint hakelt der imonc
    status_wan_new="offline"
    if [ "$status_wan_old" = "offline" ]
    then
	colecho "OPT_FAXSEND Router war offline, Start online" rd 0 br
	while [ "$status_wan_new" = "offline" ]
	do
	    # connect to wan -> ONLINE
	    { echo "dial"; echo "quit"; } | netcat -w 1 127.0.0.1 $imond_port
	    # Test if online
	    status_dsl=`fli4lctrl status pppoe`

	    if ( `isdnctrl status all | grep to >/dev/null` )
	    then
            colecho "OPT_FAXSEND meldet online (ISDN) ...." gn 0 br
		status_isdn="online"
   	    fi

	    if [ "$status_dsl" = "online" ] 
	    then
		status_wan_new="online"
	    fi
	    if [ "$status_isdn" = "online" ] 
	    then
		status_wan_new="online"
	    fi
	    sleep 10 # repeat loop every 10secs
	    colecho "OPT_FAXSEND Router meldet noch offline ...." rd 0 br
	done	  
	colecho "OPT_FAXSEND Router online !" gn 
    fi
}
# endof wan_connect



#-------------------------------------------------------------------------
# disconnect from wan(if offline at beginning) to wan
#-------------------------------------------------------------------------
wan_disconnect ()
{
    # gehe offline, wenn vor dem Faxversand offline war
    if [ "$status_wan_old" = "offline" ]
    then
	colecho "OPT_FAXSEND Router wieder offline nehmen" rd 0 br 
	while [ "$status_wan_new" = "online" ]
	do
	    { echo "hangup"; echo "quit"; } | netcat -w 1 127.0.0.1 $imond_port

	    # Test if online
	    status_dsl=`fli4lctrl status pppoe`
	    if ( `isdnctrl status all | grep not >/dev/null` )
	    then
		colecho "OPT_FAXSEND Router meldet OFFLINE (ISDN) " gn
		status_isdn="offline"
	    fi

	    if [ "$status_dsl" != "online" ] 
	    then
		if [ "$status_isdn" != "online" ] 
		then
		    status_wan_new="offline"
		fi   
	    fi

	    sleep 20 # repeat loop every 20secs
	    colecho "OPT_FAXSEND Router meldet noch ONLINE ...." rd 0 br

	done	  
	colecho "OPT_FAXSEND Router offline !" gn

    else
	colecho "OPT_FAXSEND Router bleibt online !" rd 0 br
    fi
}
# endof wan_disconnect











#------------------------------------------------------------------------------
# SCRIPT START
#------------------------------------------------------------------------------

# initialize...
initialize

exec > $FAXSEND_REDIRECT 2>&1
echo
colecho "OPT_FAXSEND: start faxsend.sh ..." gn 0 br

while [ "$1" ]
do
    case $1 in
	*[^0-9]*)

	    fax=$1
	    filename=`basename $fax`
	    directory=`dirname $fax`
	    mfax=$directory'/mfax.log'
	    colecho "OPT_FAXSEND Parameter Fax: $fax" cy
	    case x$2 in
		x) csid=$FAXRCV_CSID 
		   colecho "OPT_FAXSEND Parameter FAXRCV_CSID: $csid" cy 			
		   ;; 
		*) csid=$2 
		   colecho "OPT_FAXSEND Parameter 2: $2" cy 
		   ;;
	    esac
	    break 
	    ;;

	*)
   	    idx="$idx $1" 
	    idxparameters=$idx
	    colecho "OPT_FAXSEND Parameter idx: $idx" cy 	
	    ;;
    esac
    shift
done

case $OPT_FAXSEND in
    yes) ;;
    *)
	colecho "OPT_FAXSEND disabled"
	exit 
	;;
esac

if [ 0$FAXSEND_N -eq 0 ]
then
    colecho "OPT_FAXSEND: faxsend_n=0"
    exit 
fi


### Make files...
make_files


# ------------------
# connect if offline
# ------------------
if [ "$onlinecheck" = "yes" ]
then
	colecho "OPT_FAXSEND onlinecheck: $onlinecheck" cy
	wan_connect
fi

for idx in $idxparameters
do
    if set | grep -q ^FAXSEND_${idx}_FROM
    then
	varupdate
	generate_smtp_cmd
	case $OPT_FAXSEND_USE_EXT_SMTP$FAXSEND_SMTP_AUTH in
		noAUTHPLAIN)	 smtp_auth ;;
		noPOPbeforeSMTP) pop_login ;;
	esac
	# send_fax	
	send_fax

    else
	colecho "OPT_FAXSEND: ignoring invalid configuration $idx"
    fi
done

# ----------------------------------
# disconnect if offline at beginning
# ----------------------------------
if [ "$onlinecheck" = "yes" ]
then
	colecho "OPT_FAXSEND onlinecheck: $onlinecheck" cy
	wan_disconnect
fi


# check whether fax on router shall be deleted and delete if delfax is yes
delete_fax="yes"
for idx in $idxparameters
do
    if set | grep -q ^FAXSEND_${idx}_FROM
    then
	eval delfax='$FAXSEND_'$idx'_DELFAX'
    	if [ "$delfax" = "no" ]
    	then
		colecho "OPT_FAXSEND DELFAX idx =no: $idx" cy
    		delete_fax="no"
	fi
    fi
done 

if [ "$delete_fax" = "yes" ]
then
	colecho "OPT_FAXSEND DELFAX: $deletefax" cy
	# ---------
	# del_fax
	# ---------
	del_fax
fi

### Make Clean :)
cleanup
